<?php
/**
 * Import helpers.
 *
 * @package Cheshalo
 */

namespace XTS\Admin\Modules\Import;

use XTS\Singleton;

if ( ! defined( 'CHESHALO_THEME_DIR' ) ) {
	exit( 'No direct script access allowed' );
}

/**
 * Import helpers.
 */
class Helpers extends Singleton {
	/**
	 * Links to replace.
	 *
	 * @var array
	 */
	public $links = array(
		'uploads' => array(
			'http://dummy.themefars.com/cheshalo2/elementor/wp-content/uploads/sites/2/',
			'https://dummy.themefars.com/cheshalo2/elementor/wp-content/uploads/sites/2/',

			'http://dummy.themefars.com/cheshalo2/megamarket-elementor/wp-content/uploads/sites/4/',
			'https://dummy.themefars.com/cheshalo2/megamarket-elementor/wp-content/uploads/sites/4/',
			'http://dummy.themefars.com/cheshalo2/megamarket/wp-content/uploads/sites/3/',
			'https://dummy.themefars.com/cheshalo2/megamarket/wp-content/uploads/sites/3/',

			'http://dummy.themefars.com/cheshalo2/accessories-elementor/wp-content/uploads/sites/6/',
			'https://dummy.themefars.com/cheshalo2/accessories-elementor/wp-content/uploads/sites/6/',
			'http://dummy.themefars.com/cheshalo2/accessories/wp-content/uploads/sites/5/',
			'https://dummy.themefars.com/cheshalo2/accessories/wp-content/uploads/sites/5/',

			'http://dummy.themefars.com/cheshalo2/mega-electronics-elementor/wp-content/uploads/sites/8/',
			'https://dummy.themefars.com/cheshalo2/mega-electronics-elementor/wp-content/uploads/sites/8/',
			'http://dummy.themefars.com/cheshalo2/mega-electronics/wp-content/uploads/sites/7/',
			'https://dummy.themefars.com/cheshalo2/mega-electronics/wp-content/uploads/sites/7/',

			'http://dummy.themefars.com/cheshalo2/furniture2-elementor/wp-content/uploads/sites/10/',
			'https://dummy.themefars.com/cheshalo2/furniture2-elementor/wp-content/uploads/sites/10/',
			'http://dummy.themefars.com/cheshalo2/furniture2/wp-content/uploads/sites/9/',
			'https://dummy.themefars.com/cheshalo2/furniture2/wp-content/uploads/sites/9/',

			'http://dummy.themefars.com/cheshalo2/plants-elementor/wp-content/uploads/sites/12/',
			'https://dummy.themefars.com/cheshalo2/plants-elementor/wp-content/uploads/sites/12/',
			'http://dummy.themefars.com/cheshalo2/plants/wp-content/uploads/sites/11/',
			'https://dummy.themefars.com/cheshalo2/plants/wp-content/uploads/sites/11/',

			'http://dummy.themefars.com/cheshalo2/kids-elementor/wp-content/uploads/sites/14/',
			'https://dummy.themefars.com/cheshalo2/kids-elementor/wp-content/uploads/sites/14/',
			'http://dummy.themefars.com/cheshalo2/kids/wp-content/uploads/sites/13/',
			'https://dummy.themefars.com/cheshalo2/kids/wp-content/uploads/sites/13/',

			'http://dummy.themefars.com/cheshalo2/games-elementor/wp-content/uploads/sites/16/',
			'https://dummy.themefars.com/cheshalo2/games-elementor/wp-content/uploads/sites/16/',
			'http://dummy.themefars.com/cheshalo2/games/wp-content/uploads/sites/15/',
			'https://dummy.themefars.com/cheshalo2/games/wp-content/uploads/sites/15/',

			'http://dummy.themefars.com/cheshalo2/farm-elementor/wp-content/uploads/sites/22/',
			'https://dummy.themefars.com/cheshalo2/farm-elementor/wp-content/uploads/sites/22/',
			'http://dummy.themefars.com/cheshalo2/farm/wp-content/uploads/sites/20/',
			'https://dummy.themefars.com/cheshalo2/farm/wp-content/uploads/sites/20/',

			'http://dummy.themefars.com/cheshalo2/pills-elementor/wp-content/uploads/sites/23/',
			'https://dummy.themefars.com/cheshalo2/pills-elementor/wp-content/uploads/sites/23/',
			'http://dummy.themefars.com/cheshalo2/pills/wp-content/uploads/sites/21/',
			'https://dummy.themefars.com/cheshalo2/pills/wp-content/uploads/sites/21/',

			'http://dummy.themefars.com/cheshalo2/wp-content/uploads/',
			'https://dummy.themefars.com/cheshalo2/wp-content/uploads/',
			'http://cheshalo.themefars.com/wp-content/uploads/',
			'https://cheshalo.themefars.com/wp-content/uploads/',
		),
		'simple'  => array(
			'http://dummy.themefars.com/cheshalo2/megamarket-elementor/',
			'https://dummy.themefars.com/cheshalo2/megamarket-elementor/',
			'http://dummy.themefars.com/cheshalo2/megamarket/',
			'https://dummy.themefars.com/cheshalo2/megamarket/',

			'http://dummy.themefars.com/cheshalo2/accessories-elementor/',
			'https://dummy.themefars.com/cheshalo2/accessories-elementor/',
			'http://dummy.themefars.com/cheshalo2/accessories/',
			'https://dummy.themefars.com/cheshalo2/accessories/',

			'http://dummy.themefars.com/cheshalo2/mega-electronics-elementor/',
			'https://dummy.themefars.com/cheshalo2/mega-electronics-elementor/',
			'http://dummy.themefars.com/cheshalo2/mega-electronics/',
			'https://dummy.themefars.com/cheshalo2/mega-electronics/',

			'http://dummy.themefars.com/cheshalo2/furniture2-elementor/',
			'https://dummy.themefars.com/cheshalo2/furniture2-elementor/',
			'http://dummy.themefars.com/cheshalo2/furniture2/',
			'https://dummy.themefars.com/cheshalo2/furniture2/',

			'http://dummy.themefars.com/cheshalo2/plants-elementor/',
			'https://dummy.themefars.com/cheshalo2/plants-elementor/',
			'http://dummy.themefars.com/cheshalo2/plants/',
			'https://dummy.themefars.com/cheshalo2/plants/',

			'http://dummy.themefars.com/cheshalo2/kids-elementor/',
			'https://dummy.themefars.com/cheshalo2/kids-elementor/',
			'http://dummy.themefars.com/cheshalo2/kids/',
			'https://dummy.themefars.com/cheshalo2/kids/',

			'http://dummy.themefars.com/cheshalo2/games-elementor/',
			'https://dummy.themefars.com/cheshalo2/games-elementor/',
			'http://dummy.themefars.com/cheshalo2/games/',
			'https://dummy.themefars.com/cheshalo2/games/',

			'http://dummy.themefars.com/cheshalo2/farm-elementor/',
			'https://dummy.themefars.com/cheshalo2/farm-elementor/',
			'http://dummy.themefars.com/cheshalo2/farm/',
			'https://dummy.themefars.com/cheshalo2/farm/',

			'http://dummy.themefars.com/cheshalo2/pills-elementor/',
			'https://dummy.themefars.com/cheshalo2/pills-elementor/',
			'http://dummy.themefars.com/cheshalo2/pills/',
			'https://dummy.themefars.com/cheshalo2/pills/',

			'http://dummy.themefars.com/cheshalo2/elementor/',
			'https://dummy.themefars.com/cheshalo2/elementor/',
			'http://dummy.themefars.com/cheshalo2/',
			'https://dummy.themefars.com/cheshalo2/',
			'https://cheshalo.themefars.com/',
			'http://cheshalo.themefars.com/',
		),
	);

	/**
	 * Init.
	 */
	public function init() {
	}

	/**
	 * Send error.
	 *
	 * @param string $message Message.
	 */
	public function send_error_message( $message ) {
		$this->send_message( 'error', $message );
	}

	/**
	 * Send success.
	 *
	 * @param string $message Message.
	 */
	public function send_success_message( $message ) {
		$this->send_message( 'success', $message );
	}

	/**
	 * Send message.
	 *
	 * @param string $status  Status.
	 * @param string $message Message.
	 */
	public function send_message( $status, $message ) {
		echo wp_json_encode(
			array(
				'status'  => $status,
				'message' => $message,
			)
		);
	}

	/**
	 * Get file data.
	 *
	 * @param string $path File path.
	 *
	 * @return false|string
	 */
	public function get_local_file_content( $path ) {
		ob_start();
		include $path;

		return ob_get_clean();
	}

	/**
	 * Get file path.
	 *
	 * @param string $file_name File name.
	 * @param string $version   Version name.
	 *
	 * @return false|string
	 */
	public function get_file_path( $file_name, $version ) {
		$file = $this->get_version_folder_path( $version ) . $file_name;

		if ( ! file_exists( $file ) ) {
			return false;
		}

		return $file;
	}

	/**
	 * Get version folder path.
	 *
	 * @param string $version Version name.
	 *
	 * @return string
	 */
	public function get_version_folder_path( $version ) {
		return CHESHALO_THEMEROOT . '/inc/admin/modules/import/dummy-data/' . $version . '/';
	}

	/**
	 * Replace link.
	 *
	 * @since 1.0.0
	 *
	 * @param string $data    Data.
	 * @param string $replace Replace.
	 *
	 * @return string|string[]
	 */
	public function links_replace( $data, $replace = '\/' ) {
		$links = $this->links;

		foreach ( $links as $key => $value ) {
			if ( 'uploads' === $key ) {
				foreach ( $value as $link ) {
					$url_data = wp_upload_dir();
					$data     = str_replace( str_replace( '/', $replace, $link ), str_replace( '/', $replace, $url_data['baseurl'] . '/' ), $data );
				}
			}

			if ( 'simple' === $key ) {
				foreach ( $value as $link ) {
					$data = str_replace( str_replace( '/', $replace, $link ), str_replace( '/', $replace, get_home_url() . '/' ), $data );
				}
			}
		}

		return $data;
	}

	/**
	 * Get imported data.
	 *
	 * @since 1.0.0
	 *
	 * @param string $version Version name.
	 *
	 * @return array
	 */
	public function get_imported_data( $version ) {
		if ( in_array( $version . '_base', $this->get_base_version(), true ) ) {
			$base = get_option( 'wd_imported_data_' . $version . '_base' );
		} else {
			$base = get_option( 'wd_imported_data_base' );
		}

		$demo = get_option( 'wd_imported_data_' . $version );

		if ( in_array( $version, $this->get_base_version(), true ) ) {
			return $demo;
		}

		if ( $demo && $base ) {
			return array_replace_recursive( $base, $demo );
		} else {
			return array();
		}
	}

	/**
	 * Get base version for import.
	 *
	 * @return array
	 */
	public function get_base_version() {
		return array( 'base', 'megamarket_base', 'accessories_base', 'mega-electronics_base', 'furniture2_base', 'plants_base', 'kids_base', 'games_base-light', 'games_base-dark', 'organic-farm_base', 'pills_base' );
	}
}
